"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RedisClient = void 0;
const redis_smq_common_1 = require("redis-smq-common");
const index_js_1 = require("../../config/index.js");
const scripts_js_1 = require("./scripts/scripts.js");
class RedisClient extends redis_smq_common_1.RedisClientFactory {
    constructor(cfg) {
        const config = cfg !== null && cfg !== void 0 ? cfg : index_js_1.Configuration.getSetConfig().redis;
        super(config);
    }
    setupClient(client, cb) {
        client.loadScriptFiles(scripts_js_1.scriptFileMap, (err) => {
            if (err)
                cb(err);
            cb(null, client);
        });
    }
}
exports.RedisClient = RedisClient;
//# sourceMappingURL=redis-client.js.map