"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.scriptFileMap = exports.ELuaScriptName = void 0;
const path_1 = require("path");
const redis_smq_common_1 = require("redis-smq-common");
var ELuaScriptName;
(function (ELuaScriptName) {
    ELuaScriptName["PUBLISH_SCHEDULED_MESSAGE"] = "PUBLISH_SCHEDULED_MESSAGE";
    ELuaScriptName["PUBLISH_MESSAGE"] = "PUBLISH_MESSAGE";
    ELuaScriptName["REQUEUE_MESSAGE"] = "REQUEUE_MESSAGE";
    ELuaScriptName["SCHEDULE_MESSAGE"] = "SCHEDULE_MESSAGE";
    ELuaScriptName["HAS_QUEUE_RATE_EXCEEDED"] = "HAS_QUEUE_RATE_EXCEEDED";
    ELuaScriptName["CREATE_QUEUE"] = "CREATE_QUEUE";
    ELuaScriptName["INIT_CONSUMER_QUEUE"] = "INIT_CONSUMER_QUEUE";
    ELuaScriptName["HANDLE_PROCESSING_QUEUE"] = "HANDLE_PROCESSING_QUEUE";
    ELuaScriptName["ACKNOWLEDGE_MESSAGE"] = "ACKNOWLEDGE_MESSAGE";
    ELuaScriptName["DELETE_MESSAGE"] = "DELETE_MESSAGE";
    ELuaScriptName["FETCH_MESSAGE_FOR_PROCESSING"] = "FETCH_MESSAGE_FOR_PROCESSING";
    ELuaScriptName["DELETE_CONSUMER_GROUP"] = "DELETE_CONSUMER_GROUP";
    ELuaScriptName["SET_QUEUE_RATE_LIMIT"] = "SET_QUEUE_RATE_LIMIT";
})(ELuaScriptName || (exports.ELuaScriptName = ELuaScriptName = {}));
const dirname = redis_smq_common_1.env.getCurrentDir();
exports.scriptFileMap = {
    [ELuaScriptName.PUBLISH_SCHEDULED_MESSAGE]: (0, path_1.resolve)(dirname, './lua/publish-scheduled-message.lua'),
    [ELuaScriptName.PUBLISH_MESSAGE]: (0, path_1.resolve)(dirname, './lua/publish-message.lua'),
    [ELuaScriptName.REQUEUE_MESSAGE]: (0, path_1.resolve)(dirname, './lua/requeue-message.lua'),
    [ELuaScriptName.SCHEDULE_MESSAGE]: (0, path_1.resolve)(dirname, './lua/schedule-message.lua'),
    [ELuaScriptName.HAS_QUEUE_RATE_EXCEEDED]: (0, path_1.resolve)(dirname, './lua/has-queue-rate-exceeded.lua'),
    [ELuaScriptName.CREATE_QUEUE]: (0, path_1.resolve)(dirname, './lua/create-queue.lua'),
    [ELuaScriptName.INIT_CONSUMER_QUEUE]: (0, path_1.resolve)(dirname, './lua/init-consumer-queue.lua'),
    [ELuaScriptName.HANDLE_PROCESSING_QUEUE]: (0, path_1.resolve)(dirname, './lua/handle-processing-queue.lua'),
    [ELuaScriptName.ACKNOWLEDGE_MESSAGE]: (0, path_1.resolve)(dirname, './lua/acknowledge-message.lua'),
    [ELuaScriptName.DELETE_MESSAGE]: (0, path_1.resolve)(dirname, './lua/delete-message.lua'),
    [ELuaScriptName.FETCH_MESSAGE_FOR_PROCESSING]: (0, path_1.resolve)(dirname, './lua/fetch-message-for-processing.lua'),
    [ELuaScriptName.DELETE_CONSUMER_GROUP]: (0, path_1.resolve)(dirname, './lua/delete-consumer-group.lua'),
    [ELuaScriptName.SET_QUEUE_RATE_LIMIT]: (0, path_1.resolve)(dirname, './lua/set-queue-rate-limit.lua'),
};
//# sourceMappingURL=scripts.js.map