"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Configuration = void 0;
const event_bus_js_1 = __importDefault(require("./event-bus.js"));
const logger_js_1 = __importDefault(require("./logger.js"));
const messages_js_1 = __importDefault(require("./messages/messages.js"));
const namespace_js_1 = __importDefault(require("./namespace.js"));
const redis_js_1 = __importDefault(require("./redis.js"));
class Configuration {
    constructor(config) {
        this.config = this.parseConfiguration(config);
    }
    static getSetConfig(config = {}) {
        if (!Configuration.instance) {
            Configuration.instance = new Configuration(config);
        }
        return Configuration.instance.getConfig();
    }
    static reset() {
        Configuration.instance = null;
    }
    getConfig() {
        return this.config;
    }
    parseConfiguration(config) {
        return {
            namespace: (0, namespace_js_1.default)(config),
            redis: (0, redis_js_1.default)(config),
            logger: (0, logger_js_1.default)(config),
            messages: (0, messages_js_1.default)(config),
            eventBus: (0, event_bus_js_1.default)(config),
        };
    }
}
exports.Configuration = Configuration;
Configuration.instance = null;
//# sourceMappingURL=configuration.js.map