"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Store;
const index_js_1 = require("../errors/index.js");
function getMessageStorageConfig(config, key) {
    var _a;
    const { store } = (_a = config.messages) !== null && _a !== void 0 ? _a : {};
    if (typeof store === 'undefined' || typeof store === 'boolean') {
        return Boolean(store);
    }
    const params = store[key];
    if (params)
        return params;
    return false;
}
function getMessageStorageParams(config, key) {
    var _a, _b;
    const params = getMessageStorageConfig(config, key);
    if (typeof params === 'boolean') {
        return {
            store: params,
            queueSize: 0,
            expire: 0,
        };
    }
    const queueSize = Number((_a = params.queueSize) !== null && _a !== void 0 ? _a : 0);
    if (isNaN(queueSize) || queueSize < 0) {
        throw new index_js_1.ConfigurationMessageQueueSizeError();
    }
    const expire = Number((_b = params.expire) !== null && _b !== void 0 ? _b : 0);
    if (isNaN(expire) || expire < 0) {
        throw new index_js_1.ConfigurationMessageStoreExpireError();
    }
    return {
        store: true,
        queueSize,
        expire,
    };
}
function Store(config) {
    return {
        acknowledged: getMessageStorageParams(config, 'acknowledged'),
        deadLettered: getMessageStorageParams(config, 'deadLettered'),
    };
}
//# sourceMappingURL=store.js.map