"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Namespace;
const redis_keys_js_1 = require("../common/redis-keys/redis-keys.js");
const index_js_1 = require("./errors/index.js");
const defaultNamespace = 'default';
function Namespace(userConfig) {
    if (!userConfig.namespace)
        return defaultNamespace;
    const ns = redis_keys_js_1.redisKeys.validateNamespace(userConfig.namespace);
    if (ns instanceof Error)
        throw new index_js_1.ConfigurationNamespaceError();
    return ns;
}
//# sourceMappingURL=namespace.js.map