"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._getConsumerQueues = _getConsumerQueues;
const redis_keys_js_1 = require("../../../../common/redis-keys/redis-keys.js");
function _getConsumerQueues(redisClient, consumerId, cb) {
    const { keyConsumerQueues } = redis_keys_js_1.redisKeys.getConsumerKeys(consumerId);
    redisClient.smembers(keyConsumerQueues, (err, reply) => {
        if (err)
            return cb(err);
        const queues = (reply !== null && reply !== void 0 ? reply : []).map((i) => JSON.parse(i));
        cb(null, queues);
    });
}
//# sourceMappingURL=_get-consumer-queues.js.map