"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.processingQueue = void 0;
const redis_smq_common_1 = require("redis-smq-common");
const redis_keys_js_1 = require("../../../../../common/redis-keys/redis-keys.js");
const _get_message_js_1 = require("../../../../message/_/_get-message.js");
exports.processingQueue = {
    fetchMessageFromProcessingQueue(redisClient, keyQueueProcessing, cb) {
        (0, redis_smq_common_1.withRedisClient)(redisClient, (client, cb) => {
            client.lrange(keyQueueProcessing, 0, 0, (err, range) => {
                if (err) {
                    return cb(err);
                }
                if (range && range.length) {
                    return (0, _get_message_js_1._getMessage)(client, range[0], cb);
                }
                cb();
            });
        }, cb);
    },
    getQueueProcessingQueues(redisClient, queue, cb) {
        const { keyQueueProcessingQueues } = redis_keys_js_1.redisKeys.getQueueKeys(queue, null);
        redisClient.hgetall(keyQueueProcessingQueues, cb);
    },
};
//# sourceMappingURL=processing-queue.js.map