export declare enum EMessageUnacknowledgementAction {
    DEAD_LETTER = 0,
    REQUEUE = 1,
    DELAY = 2
}
export declare enum EMessageUnacknowledgementDeadLetterReason {
    TTL_EXPIRED = 0,
    RETRY_THRESHOLD_EXCEEDED = 1,
    PERIODIC_MESSAGE = 2
}
export declare enum EMessageUnacknowledgementReason {
    TIMEOUT = 0,
    CONSUME_ERROR = 1,
    UNACKNOWLEDGED = 2,
    OFFLINE_CONSUMER = 3,
    OFFLINE_MESSAGE_HANDLER = 4,
    TTL_EXPIRED = 5
}
export type TMessageUnacknowledgementAction = {
    action: EMessageUnacknowledgementAction.REQUEUE | EMessageUnacknowledgementAction.DELAY;
} | {
    action: EMessageUnacknowledgementAction.DEAD_LETTER;
    deadLetterReason: EMessageUnacknowledgementDeadLetterReason;
};
export type TMessageUnacknowledgementStatus = Record<string, TMessageUnacknowledgementAction>;
//# sourceMappingURL=message-unacknowledgement.d.ts.map