import { ICallback, ILogger, Runnable, WorkerResourceGroup } from 'redis-smq-common';
import { TConsumerMessageHandlerEvent, TRedisSMQEvent } from '../../../../common/index.js';
import { RedisClient } from '../../../../common/redis-client/redis-client.js';
import { EventBus } from '../../../../common/index.js';
import { IQueueParsedParams } from '../../../queue/index.js';
import { Consumer } from '../../consumer/consumer.js';
import { IConsumerMessageHandlerArgs } from '../../types/index.js';
import { ConsumeMessage } from './consume-message/consume-message.js';
import { DequeueMessage } from './dequeue-message/dequeue-message.js';
export declare class MessageHandler extends Runnable<TConsumerMessageHandlerEvent> {
    protected consumer: Consumer;
    protected consumerId: string;
    protected queue: IQueueParsedParams;
    protected logger: ILogger;
    protected dequeueMessage: DequeueMessage;
    protected consumeMessage: ConsumeMessage;
    protected messageHandler: import("../../types/message-handler.js").TConsumerMessageHandler;
    protected autoDequeue: boolean;
    protected redisClient: RedisClient;
    protected eventBus: EventBus | null;
    protected workerResourceGroup: WorkerResourceGroup | null;
    constructor(consumer: Consumer, redisClient: RedisClient, handlerParams: IConsumerMessageHandlerArgs, autoDequeue: boolean | undefined, eventBus: EventBus | null);
    protected initDequeueMessageInstance(): DequeueMessage;
    protected initConsumeMessageInstance(): ConsumeMessage;
    protected onMessageReceived: TRedisSMQEvent['consumer.dequeueMessage.messageReceived'];
    protected onMessageUnacknowledged: TRedisSMQEvent['consumer.consumeMessage.messageUnacknowledged'];
    protected onMessageAcknowledged: TRedisSMQEvent['consumer.consumeMessage.messageAcknowledged'];
    protected onMessageNext: TRedisSMQEvent['consumer.dequeueMessage.nextMessage'];
    protected onError: (err: Error) => void;
    protected registerSystemEvents: () => void;
    protected getLogger(): ILogger;
    protected handleError(err: Error): void;
    protected setUpConsumerWorkers: (cb: ICallback<void>) => void;
    protected shutDownConsumerWorkers: (cb: ICallback<void>) => void;
    protected goingUp(): ((cb: ICallback<void>) => void)[];
    protected goingDown(): ((cb: ICallback<void>) => void)[];
    processMessage(messageId: string): void;
    next(): void;
    dequeue(): void;
    getQueue(): IQueueParsedParams;
}
//# sourceMappingURL=message-handler.d.ts.map