"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._getExchangeQueues = _getExchangeQueues;
const _get_fan_out_exchange_queues_js_1 = require("../exchange-fan-out/_/_get-fan-out-exchange-queues.js");
const _get_topic_exchange_queues_js_1 = require("../exchange-topic/_/_get-topic-exchange-queues.js");
const index_js_1 = require("../types/index.js");
function _getExchangeQueues(redisClient, exchangeParams, cb) {
    if (exchangeParams.type === index_js_1.EExchangeType.TOPIC) {
        (0, _get_topic_exchange_queues_js_1._getTopicExchangeQueues)(redisClient, exchangeParams.params, cb);
    }
    else if (exchangeParams.type === index_js_1.EExchangeType.FANOUT) {
        (0, _get_fan_out_exchange_queues_js_1._getFanOutExchangeQueues)(redisClient, exchangeParams.params, cb);
    }
    else {
        cb(null, [exchangeParams.params]);
    }
}
//# sourceMappingURL=_get-exchange-queues.js.map