"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._getFanOutExchangeQueues = _getFanOutExchangeQueues;
const redis_keys_js_1 = require("../../../../common/redis-keys/redis-keys.js");
function _getFanOutExchangeQueues(redisClient, exchange, cb) {
    const { keyExchangeBindings } = redis_keys_js_1.redisKeys.getFanOutExchangeKeys(exchange);
    redisClient.sscanAll(keyExchangeBindings, {}, (err, reply) => {
        if (err)
            cb(err);
        else {
            const queues = (reply !== null && reply !== void 0 ? reply : []).map((i) => JSON.parse(i));
            cb(null, queues);
        }
    });
}
//# sourceMappingURL=_get-fan-out-exchange-queues.js.map