"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._getMessageState = _getMessageState;
const redis_keys_js_1 = require("../../../common/redis-keys/redis-keys.js");
const index_js_1 = require("../errors/index.js");
const index_js_2 = require("../types/index.js");
function _getMessageState(redisClient, messageId, cb) {
    const { keyMessage } = redis_keys_js_1.redisKeys.getMessageKeys(messageId);
    redisClient.hget(keyMessage, String(index_js_2.EMessageProperty.STATE), (err, reply) => {
        if (err)
            cb(err);
        else if (!reply)
            cb(new index_js_1.MessageMessageNotFoundError());
        else
            cb(null, JSON.parse(reply));
    });
}
//# sourceMappingURL=_get-message-state.js.map