import { TExchangeTransferable } from '../../exchange/index.js';
import { IQueueParams } from '../../queue/index.js';
import { IMessageStateTransferable } from './message-state.js';
export declare enum EMessagePriority {
    HIGHEST = 0,
    VERY_HIGH = 1,
    HIGH = 2,
    ABOVE_NORMAL = 3,
    NORMAL = 4,
    LOW = 5,
    VERY_LOW = 6,
    LOWEST = 7
}
export declare enum EMessageProperty {
    ID = 0,
    STATUS = 1,
    STATE = 2,
    MESSAGE = 3
}
export declare enum EMessagePropertyStatus {
    UNPUBLISHED = -1,
    SCHEDULED = 0,
    PENDING = 1,
    PROCESSING = 2,
    ACKNOWLEDGED = 3,
    UNACK_DELAYING = 4,
    UNACK_REQUEUING = 5,
    DEAD_LETTERED = 6
}
export interface IMessageParams {
    createdAt: number;
    exchange: TExchangeTransferable;
    ttl: number;
    retryThreshold: number;
    retryDelay: number;
    consumeTimeout: number;
    body: unknown;
    priority: number | null;
    scheduledCron: string | null;
    scheduledDelay: number | null;
    scheduledRepeatPeriod: number | null;
    scheduledRepeat: number;
    destinationQueue: IQueueParams;
    consumerGroupId: string | null;
}
export interface IMessageTransferable extends IMessageParams {
    id: string;
    messageState: IMessageStateTransferable;
    status: EMessagePropertyStatus;
}
export type TMessageConsumeOptions = {
    ttl: number;
    retryThreshold: number;
    retryDelay: number;
    consumeTimeout: number;
};
//# sourceMappingURL=message.d.ts.map