"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueueAcknowledgedMessages = void 0;
const redis_client_js_1 = require("../../../common/redis-client/redis-client.js");
const index_js_1 = require("../../message/index.js");
const queue_messages_manager_abstract_js_1 = require("../queue-messages-manager/queue-messages-manager-abstract.js");
const queue_messages_storage_list_js_1 = require("../queue-messages-storage/queue-messages-storage-list.js");
class QueueAcknowledgedMessages extends queue_messages_manager_abstract_js_1.QueueMessagesManagerAbstract {
    constructor() {
        const redisClient = new redis_client_js_1.RedisClient();
        super(redisClient, new queue_messages_storage_list_js_1.QueueMessagesStorageList(redisClient), new index_js_1.Message(), 'keyQueueAcknowledged');
        this.logger.debug('QueueAcknowledgedMessages initialized');
    }
}
exports.QueueAcknowledgedMessages = QueueAcknowledgedMessages;
//# sourceMappingURL=queue-acknowledged-messages.js.map