import { ICallback } from 'redis-smq-common';
import { IQueueParams } from '../../queue/index.js';
import { QueueMessagesManagerAbstract } from '../queue-messages-manager/queue-messages-manager-abstract.js';
import { QueueAcknowledgedMessages } from './queue-acknowledged-messages.js';
import { QueueDeadLetteredMessages } from './queue-dead-lettered-messages.js';
import { SequentialQueuePendingMessages } from './queue-pending-messages/sequential-queue-pending-messages.js';
import { PriorityQueuePendingMessages } from './queue-pending-messages/priority-queue-pending-messages.js';
import { QueueScheduledMessages } from './queue-scheduled-messages.js';
import { IQueueMessagesCount } from '../types/index.js';
export declare class QueueMessages extends QueueMessagesManagerAbstract {
    protected readonly priorityQueueMessages: PriorityQueuePendingMessages;
    protected readonly queuePendingMessages: SequentialQueuePendingMessages;
    protected readonly queueDeadLetteredMessages: QueueDeadLetteredMessages;
    protected readonly queueScheduledMessages: QueueScheduledMessages;
    protected readonly queueAcknowledgedMessages: QueueAcknowledgedMessages;
    constructor();
    countMessagesByStatus(queue: string | IQueueParams, cb: ICallback<IQueueMessagesCount>): void;
    private executeCountingPipeline;
    private getQueueProperties;
    private countPendingMessages;
    private countPendingByGroupId;
    shutdown(cb: ICallback<void>): void;
}
//# sourceMappingURL=queue-messages.d.ts.map