"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PriorityQueuePendingMessages = void 0;
const redis_client_js_1 = require("../../../../common/redis-client/redis-client.js");
const index_js_1 = require("../../../message/index.js");
const queue_messages_manager_abstract_js_1 = require("../../queue-messages-manager/queue-messages-manager-abstract.js");
const queue_messages_storage_sorted_set_js_1 = require("../../queue-messages-storage/queue-messages-storage-sorted-set.js");
class PriorityQueuePendingMessages extends queue_messages_manager_abstract_js_1.QueueMessagesManagerAbstract {
    constructor() {
        const redisClient = new redis_client_js_1.RedisClient();
        super(redisClient, new queue_messages_storage_sorted_set_js_1.QueueMessagesStorageSortedSet(redisClient), new index_js_1.Message(), 'keyQueuePriorityPending');
        this.requireGroupId = true;
        this.logger.debug('PriorityQueuePendingMessages initialized');
    }
}
exports.PriorityQueuePendingMessages = PriorityQueuePendingMessages;
//# sourceMappingURL=priority-queue-pending-messages.js.map