import { ICallback } from 'redis-smq-common';
import { RedisClient } from '../../../../common/redis-client/redis-client.js';
import { IMessageTransferable } from '../../../message/index.js';
import { IQueueParsedParams, TQueueExtendedParams } from '../../../queue/index.js';
import { IQueueMessageManager, IQueueMessagesPage } from '../../types/index.js';
import { SequentialQueuePendingMessages } from './sequential-queue-pending-messages.js';
import { PriorityQueuePendingMessages } from './priority-queue-pending-messages.js';
export declare class QueuePendingMessages implements IQueueMessageManager {
    protected redisClient: RedisClient;
    protected priorityQueueMessages: PriorityQueuePendingMessages;
    protected sequentialQueuePendingMessages: SequentialQueuePendingMessages;
    protected logger: import("redis-smq-common").ILogger;
    constructor();
    protected getQueueImplementation(queue: IQueueParsedParams, cb: ICallback<IQueueMessageManager>): void;
    countMessages(queue: TQueueExtendedParams, cb: ICallback<number>): void;
    getMessages(queue: TQueueExtendedParams, page: number, pageSize: number, cb: ICallback<IQueueMessagesPage<IMessageTransferable>>): void;
    purge(queue: TQueueExtendedParams, cb: ICallback<void>): void;
    shutdown: (cb: ICallback<void>) => void;
}
//# sourceMappingURL=queue-pending-messages.d.ts.map