"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._hasRateLimitExceeded = _hasRateLimitExceeded;
const scripts_js_1 = require("../../../common/redis-client/scripts/scripts.js");
const redis_keys_js_1 = require("../../../common/redis-keys/redis-keys.js");
function _hasRateLimitExceeded(redisClient, queue, rateLimit, cb) {
    const { limit, interval } = rateLimit;
    const { keyQueueRateLimitCounter } = redis_keys_js_1.redisKeys.getQueueKeys(queue, null);
    redisClient.runScript(scripts_js_1.ELuaScriptName.HAS_QUEUE_RATE_EXCEEDED, [keyQueueRateLimitCounter], [limit, interval], (err, reply) => {
        if (err)
            cb(err);
        else {
            const hasExceeded = Boolean(reply);
            cb(null, hasExceeded);
        }
    });
}
//# sourceMappingURL=_has-rate-limit-exceeded.js.map