"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._getQueueConsumers = _getQueueConsumers;
const redis_smq_common_1 = require("redis-smq-common");
const redis_keys_js_1 = require("../../../common/redis-keys/redis-keys.js");
function _getQueueConsumers(client, queue, cb) {
    const { keyQueueConsumers } = redis_keys_js_1.redisKeys.getQueueKeys(queue, null);
    client.hgetall(keyQueueConsumers, (err, reply) => {
        if (err)
            return cb(err);
        const consumers = reply !== null && reply !== void 0 ? reply : {};
        const data = {};
        redis_smq_common_1.async.eachIn(consumers, (item, key, done) => {
            data[key] = JSON.parse(item);
            done();
        }, () => cb(null, data));
    });
}
//# sourceMappingURL=_get-queue-consumers.js.map