"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._getQueues = _getQueues;
const redis_smq_common_1 = require("redis-smq-common");
const redis_keys_js_1 = require("../../../common/redis-keys/redis-keys.js");
function _getQueues(client, cb) {
    const { keyQueues } = redis_keys_js_1.redisKeys.getMainKeys();
    client.sscanAll(keyQueues, {}, (err, reply) => {
        if (err)
            cb(err);
        else if (!reply)
            cb(new redis_smq_common_1.CallbackEmptyReplyError());
        else {
            const queues = reply.map((i) => JSON.parse(i));
            cb(null, queues);
        }
    });
}
//# sourceMappingURL=_get-queues.js.map