"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._parseQueueExtendedParams = _parseQueueExtendedParams;
const redis_keys_js_1 = require("../../../common/redis-keys/redis-keys.js");
const index_js_1 = require("../errors/index.js");
const _parse_queue_params_js_1 = require("./_parse-queue-params.js");
function isQueueParams(args) {
    return (!!args &&
        typeof args === 'object' &&
        Object.keys(args).includes('ns') &&
        Object.keys(args).includes('name'));
}
function _parseQueueExtendedParams(args) {
    if (typeof args === 'string') {
        const queueParams = (0, _parse_queue_params_js_1._parseQueueParams)(args);
        if (queueParams instanceof Error)
            return queueParams;
        return {
            queueParams,
            groupId: null,
        };
    }
    if (isQueueParams(args)) {
        const queueParams = (0, _parse_queue_params_js_1._parseQueueParams)(args);
        if (queueParams instanceof Error)
            return queueParams;
        return {
            queueParams,
            groupId: null,
        };
    }
    const queueParams = (0, _parse_queue_params_js_1._parseQueueParams)(args.queue);
    if (queueParams instanceof Error)
        return queueParams;
    let groupId = null;
    if (args.groupId) {
        groupId = redis_keys_js_1.redisKeys.validateRedisKey(args.groupId);
        if (groupId instanceof Error)
            return new index_js_1.QueueInvalidQueueParameterError();
    }
    return {
        queueParams,
        groupId,
    };
}
//# sourceMappingURL=_parse-queue-extended-params.js.map