"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._parseQueueParamsAndValidate = _parseQueueParamsAndValidate;
const index_js_1 = require("../errors/index.js");
const _parse_queue_params_js_1 = require("./_parse-queue-params.js");
const _queue_exists_js_1 = require("./_queue-exists.js");
function _parseQueueParamsAndValidate(redisClient, queue, cb) {
    const queueParams = (0, _parse_queue_params_js_1._parseQueueParams)(queue);
    if (queueParams instanceof Error)
        cb(queueParams);
    else
        (0, _queue_exists_js_1._queueExists)(redisClient, queueParams, (err, reply) => {
            if (err)
                cb(err);
            else if (!reply)
                cb(new index_js_1.QueueQueueNotFoundError());
            else
                cb(null, queueParams);
        });
}
//# sourceMappingURL=_parse-queue-params-and-validate.js.map