"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._parseQueueParams = _parseQueueParams;
const index_js_1 = require("../../../common/redis-keys/errors/index.js");
const redis_keys_js_1 = require("../../../common/redis-keys/redis-keys.js");
const index_js_2 = require("../../../config/index.js");
const index_js_3 = require("../errors/index.js");
function _parseQueueParams(queue) {
    const queueParams = typeof queue === 'string' ? { name: queue } : queue;
    const name = redis_keys_js_1.redisKeys.validateRedisKey(queueParams.name);
    if (name instanceof index_js_1.RedisKeysError)
        return new index_js_3.QueueInvalidQueueParameterError();
    const ns = queueParams.ns
        ? redis_keys_js_1.redisKeys.validateNamespace(queueParams.ns)
        : index_js_2.Configuration.getSetConfig().namespace;
    if (ns instanceof index_js_1.RedisKeysError)
        return new index_js_3.QueueInvalidQueueParameterError();
    return {
        name,
        ns,
    };
}
//# sourceMappingURL=_parse-queue-params.js.map