export declare enum EQueueType {
    LIFO_QUEUE = 0,
    FIFO_QUEUE = 1,
    PRIORITY_QUEUE = 2
}
export interface IQueueParams {
    name: string;
    ns: string;
}
export interface IQueueConsumerGroupParams {
    queue: string | IQueueParams;
    groupId: string | null;
}
export type TQueueExtendedParams = string | IQueueParams | IQueueConsumerGroupParams;
export interface IQueueParsedParams {
    queueParams: IQueueParams;
    groupId: string | null;
}
export interface IQueueRateLimit {
    limit: number;
    interval: number;
}
export declare enum EQueueDeliveryModel {
    POINT_TO_POINT = 0,
    PUB_SUB = 1
}
export interface IQueueProperties {
    deliveryModel: EQueueDeliveryModel;
    queueType: EQueueType;
    rateLimit: IQueueRateLimit | null;
    exchange: string | null;
    messagesCount: number;
}
export declare enum EQueueProperty {
    QUEUE_TYPE = 0,
    RATE_LIMIT = 1,
    EXCHANGE = 2,
    MESSAGES_COUNT = 3,
    DELIVERY_MODEL = 4
}
//# sourceMappingURL=queue.d.ts.map