import { RedisClientFactory, } from 'redis-smq-common';
import { Configuration } from '../../config/index.js';
import { scriptFileMap } from './scripts/scripts.js';
export class RedisClient extends RedisClientFactory {
    constructor(cfg) {
        const config = cfg ?? Configuration.getSetConfig().redis;
        super(config);
    }
    setupClient(client, cb) {
        client.loadScriptFiles(scriptFileMap, (err) => {
            if (err)
                cb(err);
            cb(null, client);
        });
    }
}
//# sourceMappingURL=redis-client.js.map