import { IQueueParams } from '../../lib/index.js';
import { RedisKeysInvalidKeyError } from './errors/index.js';
export declare const redisKeys: {
    getNamespaceKeys(ns: string): {
        keyNamespaceQueues: string;
    };
    getQueueKeys(queueParams: IQueueParams, consumerGroupId: string | null): {
        keyQueuePending: string;
        keyQueuePriorityPending: string;
        keyQueueDL: string;
        keyQueueProcessingQueues: string;
        keyQueueAcknowledged: string;
        keyQueueScheduled: string;
        keyQueueRequeued: string;
        keyQueueDelayed: string;
        keyQueueConsumers: string;
        keyQueueRateLimitCounter: string;
        keyQueueProperties: string;
        keyQueueMessages: string;
        keyQueueMessageIds: string;
        keyQueueConsumerGroups: string;
        keyQueueWorkersLock: string;
    };
    getMessageKeys(messageId: string): {
        keyMessage: string;
    };
    getFanOutExchangeKeys(bindingKey: string): {
        keyExchangeBindings: string;
    };
    getConsumerKeys(instanceId: string): {
        keyConsumerQueues: string;
        keyConsumerHeartbeat: string;
    };
    getQueueConsumerKeys(queueParams: IQueueParams, instanceId: string): {
        keyQueueProcessing: string;
    };
    getMainKeys(): Record<"keyQueues" | "keyNamespaces" | "keyFanOutExchanges", string>;
    validateNamespace(ns: string): string | RedisKeysInvalidKeyError;
    validateRedisKey(key: string | null | undefined): string | RedisKeysInvalidKeyError;
    getKeySegmentSeparator(): ":";
};
//# sourceMappingURL=redis-keys.d.ts.map