import EventBus from './event-bus.js';
import Logger from './logger.js';
import Messages from './messages/messages.js';
import Namespace from './namespace.js';
import Redis from './redis.js';
export class Configuration {
    static instance = null;
    config;
    constructor(config) {
        this.config = this.parseConfiguration(config);
    }
    static getSetConfig(config = {}) {
        if (!Configuration.instance) {
            Configuration.instance = new Configuration(config);
        }
        return Configuration.instance.getConfig();
    }
    static reset() {
        Configuration.instance = null;
    }
    getConfig() {
        return this.config;
    }
    parseConfiguration(config) {
        return {
            namespace: Namespace(config),
            redis: Redis(config),
            logger: Logger(config),
            messages: Messages(config),
            eventBus: EventBus(config),
        };
    }
}
//# sourceMappingURL=configuration.js.map