import { redisKeys } from '../common/redis-keys/redis-keys.js';
import { ConfigurationNamespaceError } from './errors/index.js';
const defaultNamespace = 'default';
export default function Namespace(userConfig) {
    if (!userConfig.namespace)
        return defaultNamespace;
    const ns = redisKeys.validateNamespace(userConfig.namespace);
    if (ns instanceof Error)
        throw new ConfigurationNamespaceError();
    return ns;
}
//# sourceMappingURL=namespace.js.map