import { ICallback, ILogger, Runnable, TRedisClientEvent } from 'redis-smq-common';
import { EventBus } from '../../../common/index.js';
import { TConsumerEvent } from '../../../common/index.js';
import { RedisClient } from '../../../common/redis-client/redis-client.js';
import { IQueueParsedParams, TQueueExtendedParams } from '../../queue/index.js';
import { ConsumerHeartbeat } from '../consumer-heartbeat/consumer-heartbeat.js';
import { MessageHandlerRunner } from '../message-handler-runner/message-handler-runner.js';
import { TConsumerMessageHandler } from '../types/index.js';
export declare class Consumer extends Runnable<TConsumerEvent> {
    protected messageHandlerRunner: MessageHandlerRunner;
    protected logger: ILogger;
    protected redisClient: RedisClient;
    protected eventBus: EventBus | null;
    protected heartbeat: ConsumerHeartbeat | null;
    constructor(enableMultiplexing?: boolean);
    protected onRedisError: TRedisClientEvent['error'];
    protected setUpHeartbeat: (cb: ICallback<void>) => void;
    protected shutDownHeartbeat: (cb: ICallback<void>) => void;
    protected runMessageHandlers: (cb: ICallback<void>) => void;
    protected shutdownMessageHandlers: (cb: ICallback<void>) => void;
    protected shutDownRedisClient: (cb: ICallback<void>) => void;
    protected goingUp(): ((cb: ICallback<void>) => void)[];
    protected goingDown(): ((cb: ICallback<void>) => void)[];
    protected up(cb: ICallback<boolean>): void;
    protected down(cb: ICallback<boolean>): void;
    protected getLogger(): ILogger;
    protected handleError(err: Error): void;
    consume(queue: TQueueExtendedParams, messageHandler: TConsumerMessageHandler, cb: ICallback<void>): void;
    cancel(queue: TQueueExtendedParams, cb: ICallback<void>): void;
    getQueues(): IQueueParsedParams[];
}
//# sourceMappingURL=consumer.d.ts.map