export function eventBusPublisher(consumer, eventBus, logger) {
    const up = (...args) => {
        const instance = eventBus.getInstance();
        if (instance instanceof Error)
            logger.error(instance);
        else
            instance.emit('consumer.up', ...args);
    };
    const down = (...args) => {
        const instance = eventBus.getInstance();
        if (instance instanceof Error)
            logger.error(instance);
        else
            instance.emit('consumer.down', ...args);
    };
    const goingUp = (...args) => {
        const instance = eventBus.getInstance();
        if (instance instanceof Error)
            logger.error(instance);
        else
            instance.emit('consumer.goingUp', ...args);
    };
    const goingDown = (...args) => {
        const instance = eventBus.getInstance();
        if (instance instanceof Error)
            logger.error(instance);
        else
            instance.emit('consumer.goingDown', ...args);
    };
    const error = (...args) => {
        const instance = eventBus.getInstance();
        if (instance instanceof Error)
            logger.error(instance);
        else
            instance.emit('consumer.error', ...args);
    };
    consumer.on('consumer.goingDown', goingDown);
    consumer.on('consumer.goingUp', goingUp);
    consumer.on('consumer.up', up);
    consumer.on('consumer.down', down);
    consumer.on('consumer.error', error);
}
//# sourceMappingURL=event-bus-publisher.js.map