export function eventBusPublisher(consumeMessage, eventBus, logger) {
    const messageDeadLettered = (...args) => {
        const instance = eventBus.getInstance();
        if (instance instanceof Error)
            logger.error(instance);
        else
            instance.emit('consumer.consumeMessage.messageDeadLettered', ...args);
    };
    const messageDelayed = (...args) => {
        const instance = eventBus.getInstance();
        if (instance instanceof Error)
            logger.error(instance);
        else
            instance.emit('consumer.consumeMessage.messageDelayed', ...args);
    };
    const messageRequeued = (...args) => {
        const instance = eventBus.getInstance();
        if (instance instanceof Error)
            logger.error(instance);
        else
            instance.emit('consumer.consumeMessage.messageRequeued', ...args);
    };
    const messageAcknowledged = (...args) => {
        const instance = eventBus.getInstance();
        if (instance instanceof Error)
            logger.error(instance);
        else
            instance.emit('consumer.consumeMessage.messageAcknowledged', ...args);
    };
    const messageUnacknowledged = (...args) => {
        const instance = eventBus.getInstance();
        if (instance instanceof Error)
            logger.error(instance);
        else
            instance.emit('consumer.consumeMessage.messageUnacknowledged', ...args);
    };
    const error = (...args) => {
        const instance = eventBus.getInstance();
        if (instance instanceof Error)
            logger.error(instance);
        else
            instance.emit('consumer.consumeMessage.error', ...args);
    };
    consumeMessage
        .on('consumer.consumeMessage.error', error)
        .on('consumer.consumeMessage.messageUnacknowledged', messageUnacknowledged)
        .on('consumer.consumeMessage.messageAcknowledged', messageAcknowledged)
        .on('consumer.consumeMessage.messageDeadLettered', messageDeadLettered)
        .on('consumer.consumeMessage.messageRequeued', messageRequeued)
        .on('consumer.consumeMessage.messageDelayed', messageDelayed);
}
//# sourceMappingURL=event-bus-publisher.js.map