import { ICallback } from 'redis-smq-common';
import { RedisClient } from '../../../../../common/redis-client/redis-client.js';
import { MessageEnvelope } from '../../../../message/message-envelope.js';
import { IQueueParams } from '../../../../queue/index.js';
import { EMessageUnacknowledgementReason, TMessageUnacknowledgementAction, TMessageUnacknowledgementStatus } from './types/index.js';
export declare class MessageUnacknowledgement {
    protected readonly logger: import("redis-smq-common").ILogger;
    protected readonly redisClient: RedisClient;
    constructor(redisClient: RedisClient);
    protected getMessageUnacknowledgementAction(message: MessageEnvelope, unacknowledgedReason: EMessageUnacknowledgementReason): TMessageUnacknowledgementAction;
    protected getMessageUnacknowledgementParameters(consumerId: string, messageOrQueue: MessageEnvelope | IQueueParams, unacknowledgementReason: EMessageUnacknowledgementReason, done: ICallback<{
        keys: string[];
        args: (string | number)[];
        unacknowledgementStatus: TMessageUnacknowledgementStatus;
    }>): void;
    protected executeMessageUnacknowledgement(keys: string[], argv: (string | number)[], messageHandlingStatus: TMessageUnacknowledgementStatus, cb: ICallback<TMessageUnacknowledgementStatus>): void;
    unacknowledgeMessage(consumerId: string, msg: MessageEnvelope, unacknowledgementReason: EMessageUnacknowledgementReason, cb: ICallback<TMessageUnacknowledgementStatus>): void;
    unacknowledgeMessagesInProcess(consumerId: string, queues: IQueueParams[] | null, unacknowledgementReason: EMessageUnacknowledgementReason, cb: ICallback<TMessageUnacknowledgementStatus>): void;
}
//# sourceMappingURL=message-unacknowledgement.d.ts.map