import { withRedisClient } from 'redis-smq-common';
import { redisKeys } from '../../../../../common/redis-keys/redis-keys.js';
import { _getMessage } from '../../../../message/_/_get-message.js';
export const processingQueue = {
    fetchMessageFromProcessingQueue(redisClient, keyQueueProcessing, cb) {
        withRedisClient(redisClient, (client, cb) => {
            client.lrange(keyQueueProcessing, 0, 0, (err, range) => {
                if (err) {
                    return cb(err);
                }
                if (range && range.length) {
                    return _getMessage(client, range[0], cb);
                }
                cb();
            });
        }, cb);
    },
    getQueueProcessingQueues(redisClient, queue, cb) {
        const { keyQueueProcessingQueues } = redisKeys.getQueueKeys(queue, null);
        redisClient.hgetall(keyQueueProcessingQueues, cb);
    },
};
//# sourceMappingURL=processing-queue.js.map