export function eventBusPublisher(dequeueMessage, eventBus, logger) {
    const messageReceived = (...args) => {
        const instance = eventBus.getInstance();
        if (instance instanceof Error)
            logger.error(instance);
        else
            instance.emit('consumer.dequeueMessage.messageReceived', ...args);
    };
    const nextMessage = (...args) => {
        const instance = eventBus.getInstance();
        if (instance instanceof Error)
            logger.error(instance);
        else
            instance.emit('consumer.dequeueMessage.nextMessage', ...args);
    };
    const error = (...args) => {
        const instance = eventBus.getInstance();
        if (instance instanceof Error)
            logger.error(instance);
        else
            instance.emit('consumer.dequeueMessage.error', ...args);
    };
    dequeueMessage
        .on('consumer.dequeueMessage.messageReceived', messageReceived)
        .on('consumer.dequeueMessage.nextMessage', nextMessage)
        .on('consumer.dequeueMessage.error', error);
}
//# sourceMappingURL=event-bus-publisher.js.map