import { _getFanOutExchangeQueues } from '../exchange-fan-out/_/_get-fan-out-exchange-queues.js';
import { _getTopicExchangeQueues } from '../exchange-topic/_/_get-topic-exchange-queues.js';
import { EExchangeType } from '../types/index.js';
export function _getExchangeQueues(redisClient, exchangeParams, cb) {
    if (exchangeParams.type === EExchangeType.TOPIC) {
        _getTopicExchangeQueues(redisClient, exchangeParams.params, cb);
    }
    else if (exchangeParams.type === EExchangeType.FANOUT) {
        _getFanOutExchangeQueues(redisClient, exchangeParams.params, cb);
    }
    else {
        cb(null, [exchangeParams.params]);
    }
}
//# sourceMappingURL=_get-exchange-queues.js.map