import { ICallback } from 'redis-smq-common';
import { IQueueParams } from '../../queue/index.js';
export declare enum EExchangeType {
    DIRECT = 0,
    FANOUT = 1,
    TOPIC = 2
}
export interface ITopicParams {
    topic: string;
    ns: string;
}
export type TExchangeDirectTransferable = {
    type: EExchangeType.DIRECT;
    params: IQueueParams;
    exchangeTag: string;
};
export type TExchangeTopicTransferable = {
    type: EExchangeType.TOPIC;
    params: ITopicParams;
    exchangeTag: string;
};
export type TExchangeFanOutTransferable = {
    type: EExchangeType.FANOUT;
    params: string;
    exchangeTag: string;
};
export type TExchangeTransferable = TExchangeDirectTransferable | TExchangeTopicTransferable | TExchangeFanOutTransferable;
export interface IExchange<ExchangeParams> {
    getQueues(exchangeParams: ExchangeParams, cb: ICallback<IQueueParams[]>): void;
}
//# sourceMappingURL=exchange.d.ts.map