import { redisKeys } from '../../../common/redis-keys/redis-keys.js';
import { MessageMessageNotFoundError } from '../errors/index.js';
import { EMessageProperty } from '../types/index.js';
export function _getMessageStatus(redisClient, messageId, cb) {
    const { keyMessage } = redisKeys.getMessageKeys(messageId);
    redisClient.hget(keyMessage, String(EMessageProperty.STATUS), (err, reply) => {
        if (err)
            cb(err);
        else if (!reply)
            cb(new MessageMessageNotFoundError());
        else
            cb(null, Number(reply));
    });
}
//# sourceMappingURL=_get-message-status.js.map