import { RedisClient } from '../../../../common/redis-client/redis-client.js';
import { Message } from '../../../message/index.js';
import { QueueMessagesManagerAbstract } from '../../queue-messages-manager/queue-messages-manager-abstract.js';
import { QueueMessagesStorageSortedSet } from '../../queue-messages-storage/queue-messages-storage-sorted-set.js';
export class PriorityQueuePendingMessages extends QueueMessagesManagerAbstract {
    requireGroupId = true;
    constructor() {
        const redisClient = new RedisClient();
        super(redisClient, new QueueMessagesStorageSortedSet(redisClient), new Message(), 'keyQueuePriorityPending');
        this.logger.debug('PriorityQueuePendingMessages initialized');
    }
}
//# sourceMappingURL=priority-queue-pending-messages.js.map