import { RedisClient } from '../../../../common/redis-client/redis-client.js';
import { Message } from '../../../message/index.js';
import { QueueMessagesManagerAbstract } from '../../queue-messages-manager/queue-messages-manager-abstract.js';
import { QueueMessagesStorageList } from '../../queue-messages-storage/queue-messages-storage-list.js';
export class SequentialQueuePendingMessages extends QueueMessagesManagerAbstract {
    requireGroupId = true;
    constructor() {
        const redisClient = new RedisClient();
        super(redisClient, new QueueMessagesStorageList(redisClient), new Message(), 'keyQueuePending');
        this.logger.debug('SequentialQueuePendingMessages initialized');
    }
}
//# sourceMappingURL=sequential-queue-pending-messages.js.map