import { RedisClient } from '../../../common/redis-client/redis-client.js';
import { Message } from '../../message/index.js';
import { QueueMessagesManagerAbstract } from '../queue-messages-manager/queue-messages-manager-abstract.js';
import { QueueMessagesStorageSortedSet } from '../queue-messages-storage/queue-messages-storage-sorted-set.js';
export class QueueScheduledMessages extends QueueMessagesManagerAbstract {
    constructor() {
        const redisClient = new RedisClient();
        redisClient.on('error', (err) => this.logger.error(err));
        super(redisClient, new QueueMessagesStorageSortedSet(redisClient), new Message(), 'keyQueueScheduled');
        this.logger.debug('QueueScheduledMessages initialized');
    }
}
//# sourceMappingURL=queue-scheduled-messages.js.map