import { ELuaScriptName } from '../../../common/redis-client/scripts/scripts.js';
import { redisKeys } from '../../../common/redis-keys/redis-keys.js';
export function _hasRateLimitExceeded(redisClient, queue, rateLimit, cb) {
    const { limit, interval } = rateLimit;
    const { keyQueueRateLimitCounter } = redisKeys.getQueueKeys(queue, null);
    redisClient.runScript(ELuaScriptName.HAS_QUEUE_RATE_EXCEEDED, [keyQueueRateLimitCounter], [limit, interval], (err, reply) => {
        if (err)
            cb(err);
        else {
            const hasExceeded = Boolean(reply);
            cb(null, hasExceeded);
        }
    });
}
//# sourceMappingURL=_has-rate-limit-exceeded.js.map