import { async } from 'redis-smq-common';
import { redisKeys } from '../../../common/redis-keys/redis-keys.js';
export function _getQueueConsumers(client, queue, cb) {
    const { keyQueueConsumers } = redisKeys.getQueueKeys(queue, null);
    client.hgetall(keyQueueConsumers, (err, reply) => {
        if (err)
            return cb(err);
        const consumers = reply ?? {};
        const data = {};
        async.eachIn(consumers, (item, key, done) => {
            data[key] = JSON.parse(item);
            done();
        }, () => cb(null, data));
    });
}
//# sourceMappingURL=_get-queue-consumers.js.map