import { QueueQueueNotFoundError } from '../errors/index.js';
import { _parseQueueParams } from './_parse-queue-params.js';
import { _queueExists } from './_queue-exists.js';
export function _parseQueueParamsAndValidate(redisClient, queue, cb) {
    const queueParams = _parseQueueParams(queue);
    if (queueParams instanceof Error)
        cb(queueParams);
    else
        _queueExists(redisClient, queueParams, (err, reply) => {
            if (err)
                cb(err);
            else if (!reply)
                cb(new QueueQueueNotFoundError());
            else
                cb(null, queueParams);
        });
}
//# sourceMappingURL=_parse-queue-params-and-validate.js.map