import { RedisKeysError } from '../../../common/redis-keys/errors/index.js';
import { redisKeys } from '../../../common/redis-keys/redis-keys.js';
import { Configuration } from '../../../config/index.js';
import { QueueInvalidQueueParameterError } from '../errors/index.js';
export function _parseQueueParams(queue) {
    const queueParams = typeof queue === 'string' ? { name: queue } : queue;
    const name = redisKeys.validateRedisKey(queueParams.name);
    if (name instanceof RedisKeysError)
        return new QueueInvalidQueueParameterError();
    const ns = queueParams.ns
        ? redisKeys.validateNamespace(queueParams.ns)
        : Configuration.getSetConfig().namespace;
    if (ns instanceof RedisKeysError)
        return new QueueInvalidQueueParameterError();
    return {
        name,
        ns,
    };
}
//# sourceMappingURL=_parse-queue-params.js.map