import { ICallback } from 'redis-smq-common';
import { EventBus } from '../../common/index.js';
import { RedisClient } from '../../common/redis-client/redis-client.js';
import { EQueueDeliveryModel, EQueueType, IQueueParams, IQueueProperties, TQueueConsumer } from './types/index.js';
export declare class Queue {
    protected redisClient: RedisClient;
    protected eventBus: EventBus;
    protected logger: import("redis-smq-common").ILogger;
    constructor();
    save(queue: string | IQueueParams, queueType: EQueueType, deliveryModel: EQueueDeliveryModel, cb: ICallback<{
        queue: IQueueParams;
        properties: IQueueProperties;
    }>): void;
    exists(queue: string | IQueueParams, cb: ICallback<boolean>): void;
    delete(queue: string | IQueueParams, cb: ICallback<void>): void;
    getProperties(queue: string | IQueueParams, cb: ICallback<IQueueProperties>): void;
    getQueues(cb: ICallback<IQueueParams[]>): void;
    getConsumers(queue: string | IQueueParams, cb: ICallback<Record<string, TQueueConsumer>>): void;
    getConsumerIds(queue: string | IQueueParams, cb: ICallback<string[]>): void;
    shutdown: (cb: ICallback<void>) => void;
}
//# sourceMappingURL=queue.d.ts.map